extends Node

var addFriendsButton
var textZone
var BACK
var OPTIONS

var profilePic = preload("res://assets/allPage/profile.png")
var binPic = preload("res://assets/allPage/bin.png")
var theme = preload("res://themes/testTheme.tres")
var panelTheme = preload("res://themes/panelAddFriends.tres")

# Called when the node enters the scene tree for the first time.
func _ready():
	var globals = get_node("/root/Globals")
	globals.LAST_WINDOWS_OPTIONS = "res://scenes/MultiMode.tscn"
	
	addFriendsButton = $MarginContainer/VBoxContainer/MarginContainer/Main/bottomZone/addFriendsZone/addFriends
	BACK = $MarginContainer/VBoxContainer/header/Control/headerContainer/HBoxContainer/back
	OPTIONS = $MarginContainer/VBoxContainer/header/Control/headerContainer/HBoxContainer/options
	textZone = $MarginContainer/VBoxContainer/MarginContainer/Main/bottomZone/addFriendsZone/friendsPseudo
	
	BACK.connect("pressed", self, "buttonHeader", ["back"])
	OPTIONS.connect("pressed", self, "buttonHeader", ["settings"])
	addFriendsButton.connect("pressed", self, "addFriend_button_pressed", ["add"])
	
	
func addFriend_button_pressed(button_name):
	var globals = get_node("/root/Globals")
	if button_name == "play":
		print("NOT YET")
	else:
		#envoie un message au serveur
		#est-ce que les joueurs inviter peuvent inviter??
		#ou seul l'hôte peut?
		#est-ce que cliquer sur retour permet de quitter le salon??
		createFriend(textZone.text)
		# Remove last pseudo
		textZone.set_text("")


func buttonHeader(button_name):
	var globals = get_node("/root/Globals")
	
	if button_name == "back":
		globals.load_new_scene("res://scenes/MultiSelectMenu.tscn")
	elif button_name == "settings":
		globals.load_new_scene("res://scenes/Settings.tscn")


func createFriend(friendPseudo):
	var globals = get_node("/root/Globals")
	var pseudo = ""+friendPseudo+""
	var playerList = $MarginContainer/VBoxContainer/MarginContainer/Main/ScrollContainer/friendsPlayerList
	# Add the variables to globals
	globals.FRIENDS.append(friendPseudo)
	globals.NUMBER_OF_FRIENDS += 1
	# Create the objects to add
	var newPlayer = HBoxContainer.new()
	var newPanel = Panel.new()
	var newPseudo = Label.new()
	var newTextureProfile = TextureButton.new()
	var newSupprButton = TextureButton.new()
	var margins = MarginContainer.new()
	# Set their values
	#HBoxContainer& margins
	newPlayer.set("custom_constants/separation", 15)
	margins.set_anchors_preset(15)
	var margin_value = 2.5
	margins.set("custom_constants/margin_top", margin_value)
	margins.set("custom_constants/margin_left", margin_value+5)
	margins.set("custom_constants/margin_bottom", margin_value)
	margins.set("custom_constants/margin_right", margin_value+5)
	##Panel
	newPanel.set_theme(panelTheme)
	newPanel.set_h_size_flags(3)
	newPanel.set_v_size_flags(3)
	newPanel.set_custom_minimum_size(Vector2(newPanel.get_size().x,30))
	## Pseudo
	newPanel.set_name(friendPseudo)
	newPseudo.set_text(friendPseudo)
	newPseudo.set_h_size_flags(3)
	newPseudo.set_v_size_flags(4)
	newPseudo.set_theme(theme)
	## Delete button
	newSupprButton.set_normal_texture(binPic)
	newSupprButton.set_expand(true)
	newSupprButton.set_stretch_mode(4)
	newSupprButton.set_custom_minimum_size(Vector2(25,25))
	newSupprButton.set_h_size_flags(9)
	newSupprButton.set_v_size_flags(7)
	newSupprButton.connect("pressed", self, "supprFriends_pressed", [friendPseudo])
	## Profile icon
	newTextureProfile.set_normal_texture(profilePic)
	newTextureProfile.set_expand(true)
	newTextureProfile.set_custom_minimum_size(Vector2(25,25))
	newTextureProfile.set_stretch_mode(4)
	newTextureProfile.set_h_size_flags(1)
	newTextureProfile.set_v_size_flags(7)
	# Add them
	newPanel.add_child(margins)
	margins.add_child(newPlayer)
	newPlayer.add_child(newTextureProfile)
	newPlayer.add_child(newPseudo)
	newPlayer.add_child(newSupprButton)
	playerList.add_child(newPanel)
	
	
func supprFriends_pressed(friendPseudo):
	var globals = get_node("/root/Globals")
	var playerList = $MarginContainer/VBoxContainer/MarginContainer/Main/ScrollContainer/friendsPlayerList
	var newList = []
	for child in playerList.get_children():
		if child.get_name() == friendPseudo:
			#globals.FRIENDS
			globals.NUMBER_OF_FRIENDS -= 1
			child.queue_free()
		else:
			newList.append(child.get_name())
	globals.FRIENDS = newList

func isFriendConnect(friendPseudo):
	# Check if this user is online
	# After that, implement pop-up window which says that someone
	# is trying to invite you, the no make nothing happen (the window
	# disapear and return false, the yes make what the function was basically
	# doing before and return true
	# If true, the addFriend function will add the player on the list and
	# redirect the friend on his multi mode page, waiting to play
	pass
